<?php

$page_security = 10;
$path_to_root="../..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/modules/import/includes/import_ui.inc");
include_once($path_to_root . "/modules/import/includes/import_db.inc");
include_once($path_to_root . "/modules/import/includes/dbf_class.php");

$_POST = stripslashes_array($_POST);

page(_("Edit Import Rules"), false, false, '', '');

if (isset($_GET['TargetTbl'])) {
	$_POST['TargetTbl'] = $_GET['TargetTbl'];
	get_table_def();
}

if ($_POST['TargetTbl'] == '') {
	display_notification(_('To entry import rules please select table on ').
		"<a href='import_main.php'>"._("main Import Script Editor page")."</a>");
	display_footer_exit();
}

function get_table_def()
{
	global $import_cfg;
	
	if (!isset($import_cfg['tables'][$_POST['TargetTbl']])) {
		return;
	}
	
	$tbldef = $import_cfg['tables'][$_POST['TargetTbl']];

	$_POST['Source'] = $tbldef['fname'];
	$_POST['ImportAll'] = $tbldef['getdeleted'];
	$_POST['Filter'] = htmlentities($tbldef['filter']);

	foreach(get_table_struct($_POST['TargetTbl']) as $fld) { // set expr. inputs
		$_POST['Expr_'.$fld[0]] = isset($tbldef['fields'][$fld[0]]) ?
			htmlentities($tbldef['fields'][$fld[0]]['eval']) : '';
	}
}

function save_table_def()
{
	$import_cfg = &$_SESSION['import_cfg'];

	if (!isset($import_cfg['tables'][$_POST['TargetTbl']])) {
		$import_cfg['tables'][$_POST['TargetTbl']] = array();
	}
	$tbldef = &$import_cfg['tables'][$_POST['TargetTbl']];
			
	$tbldef['fname'] = $_POST['Source'];
	$tbldef['filter'] = html_entity_decode($_POST['Filter']);
	$tbldef['getdeleted'] = isset($_POST['ImportAll']) ? 1 : 0;

	foreach(get_table_struct($_POST['TargetTbl']) as $fld) { // save expr. inputs
		$expr = trim(get_post('Expr_'.$fld[0]));
		if ($expr != '')
			$tbldef['fields'][$fld[0]]['eval'] = 
				html_entity_decode($expr);
		else // delete empty field def.
			if(isset($tbldef['fields'][$fld[0]]))
				unset($tbldef['fields'][$fld[0]]);
	}
 if ($tbldef['filter'] == '' && 
 	(!isset($tbldef['fields']) || !count($tbldef['fields'])))
 	unset($import_cfg['tables'][$_POST['TargetTbl']]);

 save_config($import_cfg['data_dir']);
}
//-------------------------------------------------------------------------------------
if (isset($_POST['Save'])) {
	save_table_def();
	meta_forward('import_main.php');
}

if (isset($_POST['Cancel'])) {
	meta_forward('import_main.php');
}

if (isset($_POST['_Source_update'])) {
	$Ajax->activate('params');
}
start_form();
hidden('TargetTbl');

div_start('params');
start_table($table_style2);

label_row(_("Target table:"), $_POST['TargetTbl']);

start_row();
label_cell(_("Source of data:"));
echo '<td>';
data_file_list('Source', $import_cfg['data_dir'], null, true);
echo get_database_view_str($_POST['Source'], _('View'));
echo '</td>';
end_row();
text_row(_("Record filter expression:"), 'Filter', null, 50, 50, 
	_('Enter expression for record selection'));
check_row( _('Import also deleted records:'), 'ImportAll', null, false,
_('Import also records marked as deleted'));

end_table(1);
div_end();
$th = array(_("Field"), _("Type"), _("Null"), _("Key"), _("Default value"), 
		_("Extra"),_("Expression"));

div_start('col_table');
start_table($table_style);
table_header($th);
$k = 0;

foreach(get_table_struct($_POST['TargetTbl']) as $tbl) {
	alt_table_row_color($k);
		foreach ($tbl as $fld) {
			label_cell($fld);
		}

	text_cells(null, 'Expr_'.$tbl[0], null, 50, 50, 
		_('Enter data import expression or input database column name'));
	end_row();
}

end_table();
div_end();

echo "<br><center>";
submit('Save', _("Save"), true, _('Save import configuration for current table'), true);
submit('Cancel', _("Cancel"), true, '', true);
echo '</center>';

end_form();

//--------------------------------------------------------------------------------------------

end_page();
exit();
?>
