<?php

include_once($path_to_root . "/includes/ui.inc");

//-----------------------------------------------------------------------------
//	Removing magic quotes from nested arrays/variables
//
function stripslashes_array($data)
{
	if(get_magic_quotes_gpc()) {
		if(is_array($data)) {
			foreach($data as $k => $v) {
				$data[$k] = stripslashes_array($data[$k]);
			}
		} else
		// stripslashes() translates '\\n' => 'n' 
			return str_replace("\\\\", "\\", $data); 
	}
	return $data;
}
//-----------------------------------------------------------------------------
//	Returns array of all FA table parameters.
//
function &get_tables_array() 
{
	global $db;

	static $tablenames;

	if (empty($tablenames)) {
		$result = db_query( "SHOW TABLES", _('Error reading FA table list'));
		while($row = db_fetch_row($result)) {
			$n = TB_PREF=='' ? $row[0] : substr($row[0], strlen(TB_PREF));
			$tablenames[$n] = $n;
		}
		ksort($tablenames);
	}
	return $tablenames;
}
//-----------------------------------------------------------------------------
//	Returns array of table field descriptions.
//
function &get_table_struct($table)
{
	global $db;
	static $fields, $last;

	if ($table != $last) {
		$result = db_query("DESCRIBE ".TB_PREF.$table, 
			'Cannot read table structure');
		if($result) {
			$fields = array();
			while($row = db_fetch_row($result)) {
				$fields[] = $row;
			}
			$last = $table;
		}
	}
	return $fields;
}


function data_file_list_row($label, $name, $dir, $value=null, $submit_on_change=false)
{
	echo "<tr><td>$label</td>\n<td>";
	data_file_list($name, $dir, $value=null, $submit_on_change);
	echo "</td></tr>\n";
}

function data_file_list($name, $dir, $value=null, $submit_on_change=false)
{
	global $path_to_root;

	$tables = array();
	$datadir = @opendir(IMPORT_DIR.'/'.$dir);
	if ($datadir)
	{
		while(false !== ($fname = readdir($datadir)))
		{
			if (!is_dir(IMPORT_DIR.'/'.$dir.'/'.$fname) 
				&& stristr($fname, '.dbf') != false)
			{
				$tables[$fname] =  $fname;
			}
		}
		ksort($tables);
	}
	array_selector( $name, $value, $tables,	
		array( 'select_submit' => $submit_on_change));
}

function data_table_list_row($label, $name, $value=null, $submit_on_change=false) 
{
	echo "<tr><td>$label</td>\n<td>";
	array_selector( $name, $value, get_tables_array(),	
		array( 'select_submit' => $submit_on_change));
	echo "</td></tr>\n";
}

function &get_import_dirs()
{
	static $sources;
	
	if (count($sources) == 0) {
		$importdir = opendir(IMPORT_DIR);
		while(false !== ($fname = readdir($importdir)))
		{
			if($fname != '.' && $fname != '..' && is_dir(IMPORT_DIR.'/'.$fname))
			{
				$sources[$fname] =  $fname;
			}
		}
		ksort($sources);
	}
	return $sources;
}

function import_dir_list_row($label, $name, $value=null)
{
	global $path_to_root;
	echo "<tr><td>$label</td>\n<td>";
	array_selector( $name, $value, get_import_dirs(), 
		array( 'select_submit'=> true, 'async' => true ) );
	echo "</td></tr>\n";
}

//--------------------------------------------------------------------------------------
//	View of dbf/FoxPro table structure.
//
function get_database_view_str($dbfname, $label)
{
	global $path_to_root, $use_popup_windows;

	$viewer = "view_dbf_struct.php";

	if ($use_popup_windows)
		$preview_str = "<a target='_blank' href='$path_to_root/modules/import/view/$viewer?dbf=$dbfname' onclick=\"javascript:openWindow(this.href,this.target); return false;\" >$label</a>";
	else
		$preview_str = "<a target='_blank' href='$path_to_root/modules/import/view/$viewer?dbf=$dbfname'>$label</a>";

	return $preview_str;
}


?>